<?php

require('./init.php');
require('./wikiContent.php');

header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Date in the past

$self = $_SERVER['PHP_SELF'];
$page =  isset($_REQUEST['page']) ? $_REQUEST['page'] : "home";
$page = strtr($page, array ("/" => "", "\\"=> "", "." => "", "\"" => "", "'" => ""));
$title = "wiki/$page";



$ver1 = getWikiContent($page, $lang, $_REQUEST['t1']);
$ver2 = getWikiContent($page, $lang, $_REQUEST['t2']);

$ver1 = tags2nl($ver1['content']);
$ver2 = tags2nl($ver2['content']);

$content = <<<EOF

<style type="text/css">
.highlight_a {
  background-color: #8ae234;
}
.highlight_c {
  background-color: #fce94f;
}
.highlight_d {
  background-color: #ef2929;
  text-decoration: line-through;
}
</style>
EOF;

$content .= strtr( highlightDiff($ver1, $ver2, PHPDiff($ver1, $ver2)), array("\n" => "<br/>"))."<div style=\"clear: both\">&nbsp;</div>";

$strViewLeft = getI18n('left', $lang);
$strViewRight = getI18n('right', $lang);
$strChanges = getI18n('changes', $lang);
$strTopics  = getI18n('topics', $lang);
$strEdit  = getI18n('edit', $lang);
$t1 = $_REQUEST['t1'];
$t2 = $_REQUEST['t2'];
$content .= <<<EOF
<div style="text-align:right;">
<a href="wiki.php?page=$page&amp;unixdts=$t1" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$strViewLeft</a>
<a href="wiki.php?page=$page&amp;unixdts=$t2" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$strViewRight</a>
<a href="wikiChanges.php?page=$page" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$strChanges</a>
<a href="wikiList.php" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$strTopics</a>
<a href="./wiki.php?page=$page" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$strEdit</a>
</div>
EOF;


require('./template.php');

?>
